=== modified file 'NEWS'
--- NEWS	2007-05-21 06:19:12 +0000
+++ NEWS	2008-03-06 01:59:26 +0000
@@ -1,12 +1,118 @@
-
 What's changed in loggerhead?
 =============================
 
+1.2.1  [06mar2008]
+------------------
+
+    - The changelog view was out of order when not using the revision
+      cache.
+
+1.2  [04mar2008]
+----------------
+
+    - Michael Hudson <michael.hudson@canonical.com> has mostly taken
+      over the maintenance of loggerhead.
+
+    - loggerhead now has a simple test suite -- use 'nosetests' in the
+      loggerhead directory to run it.
+
+    - The rendering performance of pages that display large amounts of
+      text was improved by a factor of 4 or so.
+
+    - loggerhead no longer caches the text of the diffs between
+      revisions.  It rarely helped and wasted a lot of disk space.
+
+    - The layout of most pages was made more "tight" to waste less
+      screen real estate, and some other UI improvements (Kent
+      Gibson).
+
+    - Much dead code was removed.
+
+    - Loggerhead now computes the files changed between revisions only
+      when it needs to know this.  This is a fairly expensive
+      operation in Bazaar, and doing it less massively improves
+      performance and memory usage in some situations.
+
+    - Loggerhead now takes a read lock on the branch being viewed for
+      the duration of each request, which improves performance
+      significantly.
+
+    - Loggerhead no longer uses the corruption-prone Berkely DB-backed
+      shelve module for its caches, and rather (ab)uses a sqlite
+      database instead.
+
+    - The creation of History objects is much faster for large
+      branches (Aaron Bentley).
+
+    - Allow the construction of URLs using revnos and file paths as
+      well as revids and fileids (bug #98826):
+
+      - For changes pages, append the newest revno to display to the
+        URL, like http://.../changes/<revno>
+
+      - For annotate pages, append the revno to display to the URL,
+        followed by the path, like http://.../annotate/<revno>/<path>
+
+      - For file listing and revision pages append the revno to
+        display to the URL, like http://.../files/<revno>
+
+      Loggerhead still generates URLs using revision and file ids for
+      the moment.
+
+    - Many bugs were fixed:
+
+      - Loggerhead does not escape special characters when embedding a
+        revision ID in a URL (bug #88286)
+
+      - Improved robustness in the face of ghosts.
+
+      - Don't crash on displaying a commit with an empty message (bug
+        #86247)
+
+      - codebrowse fails with infinite redirections (James Henstridge,
+        bug #89854)
+
+      - Loggerhead fails to browse revisions that change binary files
+        (James Henstridge, bug #91686)
+
+      - Loggerhead atom feeds expose internal hostname (James
+        Henstridge, bug #93585)
+
+      - loggerhead don't like page break character (0x0C) in text
+        files (bug #113313)
+
+      - codebrowse source listings don't contain line number anchors
+        (bug #98826)
+
+      - only serve up unescaped user content with "Content-Disposition:
+        attachment"
+
+      - viewing the file listing consumes a lot memory (bug #116869)
+
+      - loggerhead can't handle empty branches (bug #119228)
+
+      - upgrading the format of a branch behind loggerhead could make
+        it fail for that branch (bug #118673)
+
+      - Error parsing non-ascii content (bug #117799)
+
+      - Loggerhead failed on whitespace-only commit messages.
+
+      - Links to diffs from within a revision do not work (bug
+        #119422)
+
+      - UTF-8 patches served as ISO-8859-1, fixed by served bundles as
+        application/octet-stream (bug #121336)
+
+      - TurboGears was turning query arguments into unicode, and bzr
+        stopped accepting unicode revids (bug #175228)
+
+
 1.1.1  [24jan2007]
 ------------------
 
     - fix broken inventory page (oops!)
-    
+
     - fix a few rendering problems with kid and safari
 
 
@@ -14,31 +120,31 @@
 ----------------
 
     - new feature to compare two revisions to each other
-    
+
     - inserted text in diffs is now blue instead of green
-    
+
     - fixed to start and stop as a daemon now (use "-f" to run in the
       foreground), and all config is in loggerhead.conf (no need to mess with
       dev.cfg)
-      
+
     - renamed show/hide javascript buttons to expand/collapse, and made them
       much faster
-      
+
     - added an atom-feed link to each branch on the browse page [elliot
       murphy]
-      
+
     - auto-publish feature for multiple branches under a single folder (see
       loggerhead.conf.example)
-      
+
     - added the ability to share cache files per-project instead of just
       per-branch
-    
+
     - added side-by-side diff display for the revision page (which is the
       default), with a button to switch between side-by-side and unified diff
       format
 
     - made caching use file locking, and close cleanly on shutdown
-    
+
     - miscellaneous speed and page-size improvements
 
 

=== modified file 'README.txt'
--- README.txt	2007-01-24 19:29:58 +0000
+++ README.txt	2008-03-03 23:10:35 +0000
@@ -1,64 +1,83 @@
 LOGGERHEAD
 ==========
 
-[ version 1.1.1 for bazaar 0.13 ]
-
-Loggerhead is a web viewer for bazaar branches.  It can be used to navigate
-a branch history, annotate files, perform searches... all the usual things.
-
-This is a TurboGears (http://www.turbogears.org) project.  It can be
-started by running::
+[ Version 1.2 for Bazaar 1.2 ]
+
+Loggerhead is a web viewer for Bazaar branches.  It can be used to
+navigate a branch history, annotate files, perform searches... all the
+usual things.
+
+To get started, first you need to create a 'loggerhead.conf' file
+specifying the branches you want to view.  A 'loggerhead.conf.example'
+file is included in the source which has comments explaining the
+various options.
+
+Loggerhead can then be started by running::
 
     $ ./start-loggerhead.py
-    
-This will run loggerhead in the background.  To stop it, run::
+
+This will run loggerhead in the background.  It listens on port 8080
+by default, so go to http://localhost:8080/ in your browser to see the
+list of bublished branches.
+
+To stop Loggerhead, run::
 
     $ ./stop-loggerhead.py
 
-If you're not familiar with TurboGears, the simplest way to get running is
-to add the following lines to your apache configuration::
+If you want to view Bazaar branches from your existing Apache
+installation, you'll need to configure Apache to proxy certain
+requests to Loggerhead.  Adding lines like this to you Apache
+configuration is one way to do this::
 
     <Location "/branches/">
         ProxyPass http://127.0.0.1:8080/
         ProxyPassReverse http://127.0.0.1:8080/
     </Location>
-    
-The config file is "loggerhead.conf".  In there, you can configure projects,
-and branches per project.  The idea is that you could be publishing several
-(possibly unrelated) projects through the same loggerhead instance, and 
-several branches for the same project.
-
-Don't bother with "dev.cfg" or any of the other TurboGears config files.
-Loggerhead overrides those values with its own.
-
-A debug and access log are stored in the logs/ folder.
+
+In the configuration file you can configure projects, and branches per
+project.  The idea is that you could be publishing several (possibly
+unrelated) projects through the same loggerhead instance, and several
+branches for the same project.  See the "loggerhead.conf.example" file
+included with the source.
+
+Although Loggerhead is a TurboGears (http://www.turbogears.org)
+project, don't bother with "dev.cfg" or any of the other TurboGears
+config files.  Loggerhead overrides those values with its own.
+
+A debug and access log are stored in the logs/ folder, relative to
+the location of the start-loggerhead.py script.
+
+You may update the Bazaar branch at any time (for example, from a cron).
+Loggerhead will notice and refresh, and Bazaar uses its own branch
+locking to prevent corruption.
 
 
 CACHES
 ------
 
-To speed up most operations, loggerhead will start creating two caches per
-branch when it first launches:
+To speed up operations with large branches, loggerhead can be configured
+to create three caches per branch when it first launches:
 
     - a revision data cache
+    - a cache of files changed in a revision
     - a text searching cache
 
-You can put the cache folder anywhere, but I find that a folder under
-the branch's .bzr/ folder is the simplest place.
-
-The caches for a branch with 10,000 revisions take about 15 minutes each
-on my machine, but YMMV.  Once they are built, they update every six hours
-or so but usually finish quickly (or instantly) after the initial creation.
-Until the revision cache is built, all operations will be slow.
-
-You may update the bazaar branch at any time (for example, from a cron).
-Loggerhead will notice and refresh, and bazaar uses its own branch locking
-to prevent corruption.
+You can put the cache folder anywhere.
+
+The revision data cache and text searching cache will be automatically
+filled once loggerhead starts up.  The caches for a branch with 15,000
+revisions take about four minutes each on a fairly fast machine, but
+mileage may vary.  Once they are built, they update every six hours or
+so but usually finish quickly (or instantly) after the initial creation.
 
 
 SUPPORT
 -------
 
-This is loosely based on bazaar-webserve, which was loosely based on hgweb.
-Discussion should take place on the bazaar-dev mailing list.
+Loggerhead is loosely based on bazaar-webserve, which was loosely
+based on hgweb.  Discussion should take place on the bazaar-dev
+mailing list at bazaar@lists.canonical.com.  You can join the list at
+<https://lists.ubuntu.com/mailman/listinfo/bazaar>.  You don't need to
+subscribe to post, but your first post will be held briefly for manual
+moderation.
 

=== modified file 'loggerhead/branchview.py'
--- loggerhead/branchview.py	2007-09-04 04:36:24 +0000
+++ loggerhead/branchview.py	2008-02-27 03:36:09 +0000
@@ -53,12 +53,12 @@
         self._config = config
         self._project_config = project_config
         self.log = logging.getLogger('loggerhead.%s' % (name,))
-        
+
         # branch history
         self._history_lock = threading.RLock()
         self._history = None
         self._closed = False
-        
+
         self.changes = ChangeLogUI(self)
         self.revision = RevisionUI(self)
         self.files = InventoryUI(self)
@@ -66,12 +66,12 @@
         self.download = DownloadUI(self)
         self.atom = AtomUI(self)
         self.bundle = BundleUI(self)
-        
+
         # force history object to be loaded:
         self.get_history()
-        
+
         turbogears.startup.call_on_shutdown.append(self.close)
-    
+
     @with_history_lock
     def close(self):
         # it's important that we cleanly detach the history, so the cache
@@ -80,13 +80,13 @@
         self._history.detach()
         self._history = None
         self._closed = True
-            
+
     config = property(lambda self: self._config)
-    
+
     name = property(lambda self: self._name)
 
     group_name = property(lambda self: self._group_name)
-    
+
     def _get_friendly_name(self):
         name = self._config.get('branch_name', None)
         if name is not None:
@@ -106,9 +106,9 @@
         # try branch-specific config?
         description = self.get_history().get_config().get_user_option('description')
         return description
-        
+
     description = property(_get_description)
-    
+
     def _get_branch_url(self):
         url = self._config.get('url', None)
         if url is not None:
@@ -120,9 +120,9 @@
         # try branch-specific config?
         url = self.get_history().get_config().get_user_option('public_branch')
         return url
-        
+
     branch_url = property(_get_branch_url)
-    
+
     @turbogears.expose()
     def index(self):
         raise HTTPRedirect(self.url('/changes'))
@@ -152,12 +152,12 @@
                 _history.use_file_cache(FileChangeCache(_history, cache_path))
                 _history.use_search_index(TextIndex(_history, cache_path))
         return self._history
-    
+
     def check_rebuild(self):
         h = self.get_history()
         if h is not None:
             h.check_rebuild()
-    
+
     def url(self, elements, **kw):
         "build an url relative to this branch"
         if not isinstance(elements, list):
@@ -170,7 +170,7 @@
     def context_url(self, elements, **kw):
         "build an url relative to this branch, bringing along browsing context"
         return self.url(elements, **util.get_context(**kw))
-    
+
     def last_updated(self):
         h = self.get_history()
         change = h.get_changes([ h.last_revid ])[0]

=== modified file 'loggerhead/changecache.py'
--- loggerhead/changecache.py	2007-09-07 16:41:32 +0000
+++ loggerhead/changecache.py	2008-02-27 03:36:09 +0000
@@ -26,13 +26,10 @@
 """
 
 import cPickle
-import logging
 import os
-import threading
 import time
 
 from loggerhead import util
-from loggerhead.util import decorator
 from loggerhead.lockfile import LockFile
 
 
@@ -107,7 +104,7 @@
     def __init__(self, history, cache_path):
         self.history = history
         self.log = history.log
-        
+
         if not os.path.exists(cache_path):
             os.mkdir(cache_path)
 
@@ -130,7 +127,7 @@
     def close(self):
         self.log.debug('Closing cache file.')
         self._closed = True
-    
+
     @with_lock
     def closed(self):
         return self._closed
@@ -138,7 +135,7 @@
     @with_lock
     def flush(self):
         pass
-    
+
     @with_lock
     def get_changes(self, revid_list):
         """
@@ -191,7 +188,7 @@
         """
         if self.closed() or self.full():
             return
-        
+
         self.log.info('Building revision cache...')
         start_time = time.time()
         last_update = time.time()

=== modified file 'loggerhead/controllers/__init__.py'
--- loggerhead/controllers/__init__.py	2007-06-19 00:27:53 +0000
+++ loggerhead/controllers/__init__.py	2008-02-27 03:35:24 +0000
@@ -20,17 +20,14 @@
 import logging
 import os
 import re
-import sys
-import time
 
 import turbogears
 from turbogears import controllers
-from cherrypy import NotFound
 from configobj import ConfigObj
 
 from loggerhead import util
 from loggerhead.branchview import BranchView
-from loggerhead.history import History, is_branch
+from loggerhead.history import is_branch
 
 log = logging.getLogger("loggerhead.controllers")
 

=== modified file 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/annotate_ui.py	2007-08-23 12:18:18 +0000
+++ loggerhead/controllers/annotate_ui.py	2008-02-27 03:35:24 +0000
@@ -17,15 +17,13 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-import datetime
 import logging
 import os
 import posixpath
-import textwrap
 import time
 
 import turbogears
-from cherrypy import HTTPError, InternalError, session
+from cherrypy import HTTPError
 
 from loggerhead import util
 

=== modified file 'loggerhead/controllers/atom_ui.py'
--- loggerhead/controllers/atom_ui.py	2007-08-30 11:39:10 +0000
+++ loggerhead/controllers/atom_ui.py	2008-02-27 03:35:24 +0000
@@ -17,7 +17,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-import cherrypy
 import turbogears
 
 from loggerhead import util

=== modified file 'loggerhead/controllers/bundle_ui.py'
--- loggerhead/controllers/bundle_ui.py	2007-09-04 04:36:24 +0000
+++ loggerhead/controllers/bundle_ui.py	2008-02-27 03:35:24 +0000
@@ -16,14 +16,11 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-import os
 import time
 
 import turbogears
 from cherrypy import HTTPRedirect, InternalError, response
 
-from loggerhead import util
-
 
 class BundleUI (object):
 

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2007-09-04 04:36:24 +0000
+++ loggerhead/controllers/changelog_ui.py	2008-02-27 03:35:24 +0000
@@ -17,11 +17,10 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-import os
 import time
 
 import turbogears
-from cherrypy import InternalError, session
+from cherrypy import InternalError
 
 from loggerhead import util
 

=== modified file 'loggerhead/controllers/download_ui.py'
--- loggerhead/controllers/download_ui.py	2007-08-23 12:18:18 +0000
+++ loggerhead/controllers/download_ui.py	2008-02-27 03:35:24 +0000
@@ -17,18 +17,12 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-import datetime
 import logging
 import mimetypes
-import os
-import posixpath
-import textwrap
 import time
 
 import turbogears
-from cherrypy import HTTPRedirect, response, session
-
-from loggerhead import util
+from cherrypy import HTTPRedirect, response
 
 
 log = logging.getLogger("loggerhead.controllers")

=== modified file 'loggerhead/controllers/inventory_ui.py'
--- loggerhead/controllers/inventory_ui.py	2007-08-22 22:39:43 +0000
+++ loggerhead/controllers/inventory_ui.py	2008-02-27 03:35:24 +0000
@@ -17,15 +17,12 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-import datetime
 import logging
-import os
 import posixpath
-import textwrap
 import time
 
 import turbogears
-from cherrypy import InternalError, session
+from cherrypy import InternalError
 
 from loggerhead import util
 

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2007-09-04 04:36:24 +0000
+++ loggerhead/controllers/revision_ui.py	2008-02-27 03:35:24 +0000
@@ -17,14 +17,10 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-import datetime
-import logging
-import os
-import textwrap
 import time
 
 import turbogears
-from cherrypy import InternalError, session
+from cherrypy import InternalError
 
 from loggerhead import util
 

=== modified file 'loggerhead/daemon.py'
--- loggerhead/daemon.py	2007-06-18 23:07:53 +0000
+++ loggerhead/daemon.py	2008-02-27 03:36:09 +0000
@@ -1,7 +1,6 @@
 # daemon code from ASPN
 
 import os
-import sys
 
 
 def daemonize(pidfile, home):
@@ -20,41 +19,41 @@
     except OSError, e:
         raise Exception("%s [%d]" % (e.strerror, e.errno))
 
-    if (pid == 0):	# The first child.
+    if (pid == 0):      # The first child.
         os.setsid()
 
         try:
-            pid = os.fork()	# Fork a second child.
+            pid = os.fork()     # Fork a second child.
         except OSError, e:
             raise Exception, "%s [%d]" % (e.strerror, e.errno)
 
-        if (pid == 0):	# The second child.
+        if (pid == 0):  # The second child.
             os.chdir(WORKDIR)
             os.umask(UMASK)
         else:
-            os._exit(0)	# Exit parent (the first child) of the second child.
+            os._exit(0) # Exit parent (the first child) of the second child.
     else:
-        os._exit(0)	# Exit parent of the first child.
+        os._exit(0)     # Exit parent of the first child.
 
-    #import resource		# Resource usage information.
+    #import resource            # Resource usage information.
     #maxfd = resource.getrlimit(resource.RLIMIT_NOFILE)[1]
     #if (maxfd == resource.RLIM_INFINITY):
     #    maxfd = MAXFD
-  
+
     # Iterate through and close all file descriptors.
     #for fd in range(3, maxfd):
     #    try:
     #        os.close(fd)
-    #    except OSError:	# ERROR, fd wasn't open to begin with (ignored)
+    #    except OSError:        # ERROR, fd wasn't open to begin with (ignored)
     #        pass
 
     # This call to open is guaranteed to return the lowest file descriptor,
     # which will be 0 (stdin), since it was closed above.
-    #os.open(REDIRECT_TO, os.O_RDWR)	# standard input (0)
+    #os.open(REDIRECT_TO, os.O_RDWR)    # standard input (0)
 
     # Duplicate standard input to standard output and standard error.
-    #os.dup2(0, 1)			# standard output (1)
-    #os.dup2(0, 2)			# standard error (2)
+    #os.dup2(0, 1)                      # standard output (1)
+    #os.dup2(0, 2)                      # standard error (2)
 
     f = open(pidfile, 'w')
     f.write('%d\n' % (os.getpid(),))

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2007-12-18 10:10:43 +0000
+++ loggerhead/history.py	2008-03-05 23:02:07 +0000
@@ -27,14 +27,9 @@
 
 
 import bisect
-import cgi
 import datetime
 import logging
-import os
-import posixpath
 import re
-import shelve
-import sys
 import textwrap
 import threading
 import time
@@ -44,15 +39,12 @@
 from loggerhead.util import decorator
 
 import bzrlib
-import bzrlib.annotate
 import bzrlib.branch
 import bzrlib.bundle.serializer
-import bzrlib.decorators
 import bzrlib.diff
 import bzrlib.errors
 import bzrlib.progress
 import bzrlib.revision
-import bzrlib.textfile
 import bzrlib.tsort
 import bzrlib.ui
 
@@ -210,10 +202,7 @@
         self = cls()
         self._branch = branch
         self._last_revid = self._branch.last_revision()
-        if self._last_revid is not None:
-            self._revision_graph = branch.repository.get_revision_graph(self._last_revid)
-        else:
-            self._revision_graph = {}
+        self._revision_graph = branch.repository.get_revision_graph(self._last_revid)
 
         if name is None:
             name = self._branch.nick
@@ -223,7 +212,11 @@
         self._full_history = []
         self._revision_info = {}
         self._revno_revid = {}
-        self._merge_sort = bzrlib.tsort.merge_sort(self._revision_graph, self._last_revid, generate_revno=True)
+        if bzrlib.revision.is_null(self._last_revid):
+            self._merge_sort = []
+        else:
+            self._merge_sort = bzrlib.tsort.merge_sort(
+                self._revision_graph, self._last_revid, generate_revno=True)
         for (seq, revid, merge_depth, revno, end_of_merge) in self._merge_sort:
             self._full_history.append(revid)
             revno_str = '.'.join(str(n) for n in revno)
@@ -252,8 +245,12 @@
     @with_branch_lock
     def out_of_date(self):
         # the branch may have been upgraded on disk, in which case we're stale.
+        newly_opened = bzrlib.branch.Branch.open(self._branch.base)
         if self._branch.__class__ is not \
-               bzrlib.branch.Branch.open(self._branch.base).__class__:
+               newly_opened.__class__:
+            return True
+        if self._branch.repository.__class__ is not \
+               newly_opened.repository.__class__:
             return True
         return self._branch.last_revision() != self._last_revid
 
@@ -266,6 +263,10 @@
     def use_search_index(self, index):
         self._index = index
 
+    @property
+    def has_revisions(self):
+        return not bzrlib.revision.is_null(self.last_revid)
+
     @with_branch_lock
     def detach(self):
         # called when a new history object needs to be created, because the
@@ -464,7 +465,7 @@
         use the URL parameters (revid, start_revid, file_id, and query) to
         determine the revision list we're viewing (start_revid, file_id, query)
         and where we are in it (revid).
-        
+
             - if a query is given, we're viewing query results.
             - if a file_id is given, we're viewing revisions for a specific
               file.
@@ -473,9 +474,9 @@
 
         these may be combined to view revisions for a specific file, from
         a specific revision, with a specific search query.
-            
+
         returns a new (revid, start_revid, revid_list) where:
-        
+
             - revid: current position within the view
             - start_revid: starting revision of this view
             - revid_list: list of revision ids for this view
@@ -607,6 +608,10 @@
 
     @with_branch_lock
     def get_changes(self, revid_list):
+        """Return a list of changes objects for the given revids.
+
+        Revisions not present and NULL_REVISION will be ignored.
+        """
         if self._change_cache is None:
             changes = self.get_changes_uncached(revid_list)
         else:
@@ -648,24 +653,18 @@
     @with_branch_lock
     @with_bzrlib_read_lock
     def get_changes_uncached(self, revid_list):
-        # Because we may loop and call get_revisions multiple times (to throw
-        # out dud revids), we grab the bzrlib read lock.
-        while True:
-            try:
-                rev_list = self._branch.repository.get_revisions(revid_list)
-            except (KeyError, bzrlib.errors.NoSuchRevision), e:
-                # this sometimes happens with arch-converted branches.
-                # i don't know why. :(
-                self.log.debug('No such revision (skipping): %s', e)
-                revid_list.remove(e.revision)
-            else:
-                break
+        revid_list = filter(lambda revid: not bzrlib.revision.is_null(revid),
+                            revid_list)
+        repo = self._branch.repository
+        parent_map = repo.get_graph().get_parent_map(revid_list)
+        present_revids = filter(lambda revid:revid in parent_map, revid_list)
+        rev_list = repo.get_revisions(present_revids)
 
-        return [self._change_from_revision(rev) for rev in rev_list]        
+        return [self._change_from_revision(rev) for rev in rev_list]
 
     def _get_deltas_for_revisions_with_trees(self, revisions):
         """Produce a list of revision deltas.
-        
+
         Note that the input is a sequence of REVISIONS, not revision_ids.
         Trees will be held in memory until the generator exits.
         Each delta is relative to the revision's lefthand predecessor.
@@ -991,4 +990,3 @@
         s = StringIO()
         bzrlib.bundle.serializer.write_bundle(self._branch.repository, revid, compare_revid, s)
         return s.getvalue()
-

=== removed file 'loggerhead/history2.py'
--- loggerhead/history2.py	2007-06-25 10:16:34 +0000
+++ loggerhead/history2.py	1970-01-01 00:00:00 +0000
@@ -1,194 +0,0 @@
-"""Extract data suitable for web presentation from Bazaar branches.
-
-The module is the interface between Loggerhead and bzrlib.  Other code in
-Loggerhead should not use bzrlib APIs, and functions and methods in this
-module should not return bzrlib data types.
-
-The core method is `History.getRevisionInfo`.  This method is meant to be
-cheap, so you should not worry about calling it multiple times with the same
-argument or calling it just to retreive a subset of the information it
-returns.
-
-Revisions are described using good old bzrlib revision ids.
-
-Revision ids, file ids, file names and file paths are always utf-8 encoded 8
-bit strings.
-"""
-
-class FileDelta(object):
-    """Information about how an inventory entry changed in a revision.
-
-    All attribute names are fairly self explanatory.  The ``*_parent`` fields
-    are the file id of the parent or ``None`` for the root.
-
-    :ivar file_id:
-    :ivar old_path:
-    :ivar new_path:
-    :ivar old_name:
-    :ivar new_name:
-    :ivar old_parent:
-    :ivar new_parent:
-    :ivar old_kind:
-    :ivar new_kind:
-    :ivar content_change:
-    :type content_change: ``bool``
-    :ivar execute_change: A boolean reflecting the new state if it changed, or
-                          ``None`` if it did not.
-    :type execute_change: ``bool`` or ``None``
-    """
-
-
-class FileChanges(object):
-    """Contains information about which files changed in a revision.
-
-    Note that the 'files changed' information is relative to left-most parent
-    by default, as in 'bzr log -v'.
-
-    :ivar deltas: A list of `FileDelta` objects.
-    :ivar fileset: ``set(d.file_id for d in self.deltas)``, but cached.
-    """
-
-class RevisionInfo(object):
-    """Contains all the immutable information Loggerhead needs about a
-    particular revision.
-
-    :ivar revid: Obvious.
-    :ivar date: The date and time this revision was committed.
-    :type date: ``datetime.datetime``
-    :ivar committer: The committer.
-    :type committer: utf-8 encoded ``str``
-    :ivar revprops: The branch properties.
-    :type revprops: A dictionary mapping ``str``\ s to ``str``\ s (both utf-8
-                    encoded).
-    :ivar message: The commit message of this revision.
-    :type message: utf-8 encoded ``str``
-    :ivar parents: The list of the revids of the revision's parents.
-    """
-
-class BranchRevisionInfo(object):
-    """Contains all the mutable information Loggerhead needs about a
-    particular revision, and points to the immutable data.
-
-    :ivar revno: The dotted revno of this revision in this branch.
-    :type revno: ``str``
-    :ivar where_merged: The list of revids that have this revision as a
-                        parent.
-    :ivar info: The corresponding `RevisionInfo`.
-    """
-
-class FileEntry(object):
-    """An entry in the list returned by `getFileList`.
-
-    :ivar path: The path of the object in the revision passed to
-                `getFileList`.
-    :ivar fileid: Obvious.
-    :ivar kind: one of ``'file'``, ``'executable'``, ``'link'`` or
-                ``'directory'``.
-    :type kind: ``str``
-    :ivar last_changed_revid: The revid of the revision in which this path
-                              last changed.  Not that this is recursive,
-                              i.e. the last_changed_revid for a directory is
-                              the revid in which the directory or anything
-                              contained in in changed.x
-    :ivar size: The size of this object in this revision in bytes.
-    :type size: ``int``
-    """
-
-class History(object):
-    """Provide the information loggerhead needs about a bzrlib Branch.
-
-    An instance of this class is effectively a wrapper around a
-    `bzrlib.branch.Branch` that translates the information provided by bzrlib
-    into a form convenient for use in loggerhead.
-
-    :ivar last_revision: The revid of the tip of the branch.
-    """
-
-    @classmethod
-    def fromBranch(cls, branch):
-        """Create and initialize a `History` object from a
-        `bzrlib.branch.Branch`.
-        """
-
-    def outOfDate(self):
-        """Decide whether this History object is still current.
-
-        At least to start with, an out of date History object should be thrown
-        away and a fresh one created.
-        """
-
-    def getRevisionInfo(self, revid):
-        """Find the `BranchRevisionInfo` object for a given revision id.
-
-        This operation is to be thought of as 'cheap', which is to say that
-        you should not worry about calling it repeatedly with the same
-        argument or about calling it just to retrieve a subset of the
-        information it includes.
-
-        :param revid: a revision id.
-        :returns: a `BranchRevisionInfo` object or ``None`` if the given
-                  revision id does not exist in the branch.
-        """
-
-    def getChanges(self, revid, other_revid=None):
-        """Find the `FileChanges` object between two revision.
-
-        :param revid: A revision id.
-        :param other_revid: The revision id to compare against.  If ``None``
-                            or not given, compare against the leftmost parent
-                            of ``revid``.
-        :returns: The corresponding `FileChanges` object.
-        """
-
-    # There will need to be some more methods here to allow searching for
-    # revisions by date, committer, commit message, etc...
-
-    def getDiff(self, revidA, revidB):
-        """Compute the diff between two revisions.
-
-        Not sure what this will return yet, probably something similar to but
-        more structured than the 'chunks' loggerhead already works with.
-        """
-
-    def getDirList(self, fileid, revid):
-        """List the files in the given directory as of the given revision.
-
-        :return: a list of `FileEntry` objects.
-        """
-
-    def getFileAnnotation(self, fileid, revid):
-        """Annotate the given file.
-
-        Not sure what this should return, mostly likely a list of
-        (revid-or-None, line contents) (and ``None`` for a binary file).
-        """
-
-    def getFileText(self, fileid, revid):
-        """Fetch the contents of a file at a particular revision.
-
-        :returns: (filename, data)
-        :rtype: ``(str, str)``
-        """
-
-    def getBundle(self, revid, compare_revid=None):
-        """Return a bundle for this revision.
-
-        Relative to compare_revid, or left-most parent if this is not supplied
-        or None.
-
-        :return: A bundle (in a string).
-        """
-
-    def normalizeRevivionSpec(self, revspec):
-        """Convert a revid or revno or 'head' to a revid.
-
-        :returns: a revision id.
-        """
-
-    def normalizeFileArguments(self, revid, fileid, filepath):
-        """Handle various ways of specifying a file in the branch.
-
-        One of ``fileid`` and ``filepath`` should be None.
-
-        :returns: (fileid, filepath)
-        """

=== removed file 'loggerhead/json.py'
--- loggerhead/json.py	2006-12-11 06:44:19 +0000
+++ loggerhead/json.py	1970-01-01 00:00:00 +0000
@@ -1,12 +0,0 @@
-# This module provides helper functions for the JSON part of your
-# view, if you are providing a JSON-based API for your app.
-
-# Here's what most rules would look like:
-# @jsonify.when("isinstance(obj, YourClass)")
-# def jsonify_yourclass(obj):
-#     return [obj.val1, obj.val2]
-# The goal is to break your objects down into simple values:
-# lists, dicts, numbers and strings
-
-from turbojson.jsonify import jsonify
-

=== modified file 'loggerhead/lockfile.py'
--- loggerhead/lockfile.py	2007-01-14 01:20:39 +0000
+++ loggerhead/lockfile.py	2008-02-27 03:36:09 +0000
@@ -35,7 +35,7 @@
     lock may be acquired multiple times by the same thread, as long as it's
     released an equal number of times.  unlike threading.Lock, this lock can
     be used across processes.
-    
+
     this uses os.open(O_CREAT|O_EXCL), which apparently works even on windows,
     but will not work over NFS, if anyone still uses that.  so don't put the
     cache folder on an NFS server...
@@ -50,7 +50,7 @@
             # remove stale locks left over from a previous run
             if time.time() - os.stat(filename).st_mtime > MAX_STALE_TIME:
                 os.remove(filename)
-    
+
     @with_lock
     def _try_acquire(self):
         if self._count > 0:
@@ -63,7 +63,7 @@
             return True
         except OSError:
             return False
-    
+
     def acquire(self):
         # try over and over, sleeping on exponential backoff with an upper limit of about 5 seconds
         pause = 0.1

=== modified file 'loggerhead/lsprof.py'
--- loggerhead/lsprof.py	2006-12-15 01:14:05 +0000
+++ loggerhead/lsprof.py	2008-02-27 03:36:09 +0000
@@ -36,7 +36,7 @@
         for pp in _g_threadmap.values():
             pp.disable()
         threading.setprofile(None)
-    
+
     threads = {}
     for tid, pp in _g_threadmap.items():
         threads[tid] = Stats(pp.getstats(), {})
@@ -112,7 +112,7 @@
         self.out_file = None
 
     def output(self, out_file):
-        self.out_file = out_file        
+        self.out_file = out_file
         print >> out_file, 'events: Ticks'
         self._print_summary()
         for entry in self.data:

=== removed file 'loggerhead/model.py'
--- loggerhead/model.py	2006-12-11 06:44:19 +0000
+++ loggerhead/model.py	1970-01-01 00:00:00 +0000
@@ -1,10 +0,0 @@
-from sqlobject import *
-
-from turbogears.database import PackageHub
-
-hub = PackageHub("loggerhead")
-__connection__ = hub
-
-# class YourDataClass(SQLObject):
-#     pass
-

=== modified file 'loggerhead/release.py'
--- loggerhead/release.py	2007-01-24 19:29:58 +0000
+++ loggerhead/release.py	2008-03-06 01:59:26 +0000
@@ -1,6 +1,6 @@
 # Release information about loggerhead
 
-version = "1.1.1-0.13"
+version = "1.2.1"
 
 description = "Loggerhead is a web viewer for projects in bazaar."
 
@@ -8,5 +8,5 @@
 email = "robey@lag.net"
 
 license = "GPL"
-url = "http://www.lag.net/loggerhead/"
-download_url = "http://www.lag.net/loggerhead/download/loggerhead-1.1.1-0.13.tar.gz"
+url = "http://launchpad.net/loggerhead"
+download_url = "https://launchpad.net/loggerhead/trunk/1.2/+download/loggerhead-1.2.tar.gz"

=== modified file 'loggerhead/templates/browse.kid'
--- loggerhead/templates/browse.kid	2007-06-08 11:52:33 +0000
+++ loggerhead/templates/browse.kid	2008-02-27 01:55:39 +0000
@@ -34,7 +34,7 @@
             <tr>
             <td class="name"> <a href="${tg.url([ '/' + project.name, view.name ])}">${view.friendly_name}</a> </td>
             <td class="description"> ${view.description} </td>
-            <td class="last-update"> ${view.get_history().last_revid and util.ago(view.last_updated()) or "(no revisions)"} </td>
+            <td class="last-update"> ${view.get_history().has_revisions and util.ago(view.last_updated()) or "(no revisions)"} </td>
             <td class="feed">
                 <a href="${tg.url([ '/' + project.name, view.name, 'atom' ])}" title="atom feed">
                     <img src="${tg.url('/static/images/feed-icon-16x16.gif')}" alt="atom feed" />

=== modified file 'loggerhead/textindex.py'
--- loggerhead/textindex.py	2007-08-28 16:11:01 +0000
+++ loggerhead/textindex.py	2008-02-27 03:36:09 +0000
@@ -25,14 +25,11 @@
     - index: 3-letter substring -> list(revids)
 """
 
-import logging
 import os
 import re
-import threading
 import time
 
 from loggerhead import util
-from loggerhead.util import decorator
 from loggerhead.lockfile import LockFile
 from loggerhead.changecache import FakeShelf
 
@@ -65,17 +62,17 @@
     def __init__(self, history, cache_path):
         self.history = history
         self.log = history.log
-        
+
         if not os.path.exists(cache_path):
             os.mkdir(cache_path)
-        
+
         self._recorded_filename = os.path.join(cache_path, 'textindex-recorded.sql')
         self._index_filename = os.path.join(cache_path, 'textindex.sql')
-        
+
         # use a lockfile since the cache folder could be shared across different processes.
         self._lock = LockFile(os.path.join(cache_path, 'index-lock'))
         self._closed = False
-        
+
         self.log.info('Using search index; %d entries.', len(self))
 
     def _index(self):
@@ -83,10 +80,10 @@
 
     def _recorded(self):
         return FakeShelf(self._recorded_filename)
-    
+
     def _is_indexed(self, revid, recorded):
         return recorded.get(util.to_utf8(revid)) is not None
-        
+
     @with_lock
     def is_indexed(self, revid):
         recorded = self._recorded()
@@ -94,7 +91,7 @@
             return self._is_indexed(revid, recorded)
         finally:
             recorded.close()
-    
+
     @with_lock
     def __len__(self):
         recorded = self._recorded()
@@ -106,15 +103,15 @@
     @with_lock
     def close(self):
         self._closed = True
-    
+
     @with_lock
     def closed(self):
         return self._closed
-    
+
     @with_lock
     def flush(self):
         pass
-    
+
     @with_lock
     def full(self):
         recorded = self._recorded()
@@ -162,7 +159,7 @@
         finally:
             index.close(commit=True)
             recorded.close(commit=True)
-    
+
     @with_lock
     def find(self, text, revid_list=None):
         index = self._index()
@@ -170,12 +167,12 @@
             text = normalize_string(text)
             if len(text) < 3:
                 return []
-    
+
             total_set = None
             if revid_list is not None:
                 total_set = set(revid_list)
             seen_all = False
-            
+
             for i in xrange(len(text) - 2):
                 sub = text[i:i + 3]
                 revid_set = index.get(sub)
@@ -194,7 +191,7 @@
                     return []
         finally:
             index.close()
-        
+
         # tricky: if seen_all is True, one of the substring indices was ALL
         # (in other words, unindexed), so our results are actually a superset
         # of the exact answer.
@@ -204,7 +201,7 @@
         # we DON'T care, and if one of the substrings hit ALL, there's a small
         # chance that we'll give a few false positives.
         return total_set
-    
+
     def check_rebuild(self, max_time=3600):
         """
         check if there are any un-indexed revisions, and if so, index them.
@@ -241,4 +238,3 @@
             time.sleep(1)
         self.log.info('Search index completed.')
         self.flush()
-

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2007-09-04 17:06:03 +0000
+++ loggerhead/util.py	2008-02-27 03:36:09 +0000
@@ -29,8 +29,6 @@
 import time
 import traceback
 
-import turbogears
-
 
 log = logging.getLogger("loggerhead.controllers")
 
@@ -107,7 +105,7 @@
                 setattr(self, key, value)
         for key, value in kw.iteritems():
             setattr(self, key, value)
-    
+
     def __repr__(self):
         out = '{ '
         for key, value in self.__dict__.iteritems():
@@ -162,7 +160,7 @@
         return '%s at %s' % (username, domains[-2])
     return '%s at %s' % (username, domains[0])
 
-    
+
 def triple_factors(min_value=1):
     factors = (1, 3)
     index = 0
@@ -180,10 +178,10 @@
     """
     given a position in a maximum range, return a list of negative and positive
     jump factors for an hgweb-style triple-factor geometric scan.
-    
+
     for example, with pos=20 and max=500, the range would be:
     [ -10, -3, -1, 1, 3, 10, 30, 100, 300 ]
-    
+
     i admit this is a very strange way of jumping through revisions.  i didn't
     invent it. :)
     """
@@ -291,7 +289,7 @@
         divisor = MEG
     else:
         divisor = KILO
-    
+
     dot = size % divisor
     base = size - dot
     dot = dot * 10 // divisor
@@ -299,7 +297,7 @@
     if dot >= 10:
         base += 1
         dot -= 10
-    
+
     out = str(base)
     if (base < 100) and (dot != 0):
         out += '.%d' % (dot,)
@@ -310,7 +308,7 @@
     elif divisor == GIG:
         out += 'G'
     return out
-    
+
 
 def fill_in_navigation(navigation):
     """
@@ -324,21 +322,21 @@
     navigation.count = len(navigation.revid_list)
     navigation.page_position = navigation.position // navigation.pagesize + 1
     navigation.page_count = (len(navigation.revid_list) + (navigation.pagesize - 1)) // navigation.pagesize
-    
+
     def get_offset(offset):
         if (navigation.position + offset < 0) or (navigation.position + offset > navigation.count - 1):
             return None
         return navigation.revid_list[navigation.position + offset]
-    
+
     navigation.prev_page_revid = get_offset(-1 * navigation.pagesize)
     navigation.next_page_revid = get_offset(1 * navigation.pagesize)
-    
+
     params = { 'file_id': navigation.file_id }
     if getattr(navigation, 'query', None) is not None:
         params['q'] = navigation.query
     else:
         params['start_revid'] = navigation.start_revid
-        
+
     if navigation.prev_page_revid:
         navigation.prev_page_url = navigation.branch.url([ navigation.scan_url, navigation.prev_page_revid ], **get_context(**params))
     if navigation.next_page_revid:
@@ -451,7 +449,7 @@
     """
     return a context map that may be overriden by specific values passed in,
     but only contains keys from the list of valid context keys.
-    
+
     if 'clear' is set, only the 'remember' context value will be added, and
     all other context will be omitted.
     """

=== modified file 'setup.py'
--- setup.py	2007-03-26 06:09:27 +0000
+++ setup.py	2008-02-28 04:34:51 +0000
@@ -15,6 +15,8 @@
     url=url,
     download_url=download_url,
     license=license,
+    maintainer="Michael Hudson",
+    maintainer_email="michael.hudson@canonical.com",
     
     install_requires = [
         "TurboGears >= 1.0b1",

